"use strict";

var _h = require("snabbdom/h");

var _h2 = _interopRequireDefault(_h);

var _ramda = require("ramda");

var _transform = require("./transform");

var _transform2 = _interopRequireDefault(_transform);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var voids = ["area", "base", "br", "col", "command", "hr", "img", "input", "keygen", "link", "meta", "param", "source", "track", "wbr"];
var tags = ["a", "abbr", "acronym", "address", "applet", "area", "article", "aside", "audio", "b", "base", "basefont", "bdi", "bdo", "bgsound", "big", "blink", "blockquote", "body", "br", "button", "canvas", "caption", "center", "cite", "code", "col", "colgroup", "command", "content", "data", "datalist", "dd", "del", "details", "dfn", "dialog", "dir", "div", "dl", "dt", "element", "em", "embed", "fieldset", "figcaption", "figure", "font", "footer", "form", "frame", "frameset", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "i", "iframe", "image", "img", "input", "ins", "isindex", "kbd", "keygen", "label", "legend", "li", "link", "listing", "main", "map", "mark", "marquee", "menu", "menuitem", "meta", "meter", "multicol", "nav", "nobr", "noembed", "noframes", "noscript", "object", "ol", "optgroup", "option", "output", "p", "param", "picture", "plaintext", "pre", "progress", "q", "rp", "rt", "rtc", "ruby", "s", "samp", "script", "section", "select", "shadow", "small", "source", "spacer", "span", "strike", "strong", "style", "sub", "summary", "sup", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "time", "title", "tr", "track", "tt", "u", "ul", "var", "video", "wbr", "xmp"];
var EMPTY_OBJECT = {};
var EMTPY_STRING = "";

module.exports = (0, _ramda.mergeAll)((0, _ramda.map)(function node(tag) {
  var withTag = (0, _ramda.concat)(tag);

  if ((0, _ramda.contains)(tag)(voids)) {
    var warning = "No inner allowed in void element <" + tag + ">";

    return _defineProperty({}, tag, function () {
      var raw = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : EMPTY_OBJECT;

      if (raw.inner || raw.children) {
        console.warn(warning);
      }

      return (0, _h2.default)(withTag(raw.selector || EMTPY_STRING), (0, _transform2.default)(raw));
    });
  }

  return _defineProperty({}, tag, function () {
    var raw = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : EMPTY_OBJECT;
    return (0, _h2.default)(withTag(raw.selector || EMTPY_STRING), (0, _transform2.default)(raw), raw.inner || raw.children || EMTPY_STRING);
  });
})(tags));